package org.apache.maven.jnlp;

/* ====================================================================
 * The Apache Software License, Version 1.1
 *
 * Copyright (c) 2002 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Apache" and "Apache Software Foundation" and
 *    "Apache Maven" must not be used to endorse or promote products
 *    derived from this software without prior written permission. For
 *    written permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    "Apache Maven", nor may "Apache" appear in their name, without
 *    prior written permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 *
 * ====================================================================
 */

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.util.Enumeration;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;
import java.util.jar.JarOutputStream;

/**
 * Updates manifest for correcting java webstart bug
 *
 * @author <a href="mailto:evenisse@ifrance.com">Emmanuel Venisse</a>
 * @version $Id: UpdateManifest.java,v 1.2 2003/07/02 08:39:18 evenisse Exp $
 */
public class UpdateManifest
{
    private File inputJar;
    private File manifest;
    private File outputDir;

    public void process() throws Exception
    {
        System.out.println("Update Manifest in " + inputJar.getName());
        JarFile jarFile = new JarFile(inputJar);
        Enumeration enum = jarFile.entries();
        File outputJar = new File(outputDir, inputJar.getName());
        FileOutputStream fos = new FileOutputStream(outputJar);
        JarOutputStream jos = new JarOutputStream(fos);
        while (enum.hasMoreElements()) {
            process(jarFile, jos, (JarEntry)enum.nextElement());
        }
        jos.close();
        jarFile.close();
        outputJar.setLastModified(inputJar.lastModified());
    }
    
    private void process(JarFile jarFile, JarOutputStream jos, JarEntry entry)
        throws Exception
    {
        InputStream is = jarFile.getInputStream(entry);
        JarEntry je = entry;
        if (entry.getName().equalsIgnoreCase("META-INF/MANIFEST.MF"))
        {
            je = new JarEntry("META-INF/MANIFEST.MF");
            is = new FileInputStream(manifest);
        }
        JarEntry destEntry = new JarEntry (je.getName()); 
        jos.putNextEntry(destEntry); 
        
        byte[] buffer = new byte[2048];
        int read = 0;
        while((read = is.read(buffer)) > 0)
        {
            jos.write(buffer, 0, read);
        }
        jos.closeEntry();
    }
    
    public void setInputJar(File input)
    {
        this.inputJar = input;
    }
    
    public File getInputJar()
    {
        return inputJar;
    }
    
    public void setManifest(File manifest)
    {
        this.manifest = manifest;
    }
    
    public File getManifest()
    {
        return manifest;
    }
    
    public void setOutputDir(File outputDir)
    {
        this.outputDir = outputDir;
    }
    
    public File getOutputDir()
    {
        return outputDir;
    }
}